/**
 */
package de.hftstuttgart.buildingphysics;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsFactory
 * @model kind="package"
 * @generated
 */
public interface BuildingPhysicsPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "buildingphysics";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.hftstuttgart.de/buildingphysics";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "buildphys";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	BuildingPhysicsPackage eINSTANCE = de.hftstuttgart.buildingphysics.impl.BuildingPhysicsPackageImpl.init();

	/**
	 * The meta object id for the '{@link de.hftstuttgart.buildingphysics.impl.BuildingPhysicsCatalogImpl <em>Catalog</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.buildingphysics.impl.BuildingPhysicsCatalogImpl
	 * @see de.hftstuttgart.buildingphysics.impl.BuildingPhysicsPackageImpl#getBuildingPhysicsCatalog()
	 * @generated
	 */
	int BUILDING_PHYSICS_CATALOG = 0;

	/**
	 * The feature id for the '<em><b>Author</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUILDING_PHYSICS_CATALOG__AUTHOR = 0;

	/**
	 * The feature id for the '<em><b>Window Catalog</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUILDING_PHYSICS_CATALOG__WINDOW_CATALOG = 1;

	/**
	 * The feature id for the '<em><b>Material Catalog</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUILDING_PHYSICS_CATALOG__MATERIAL_CATALOG = 2;

	/**
	 * The number of structural features of the '<em>Catalog</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUILDING_PHYSICS_CATALOG_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Catalog</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUILDING_PHYSICS_CATALOG_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.buildingphysics.impl.WindowTypeImpl <em>Window Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.buildingphysics.impl.WindowTypeImpl
	 * @see de.hftstuttgart.buildingphysics.impl.BuildingPhysicsPackageImpl#getWindowType()
	 * @generated
	 */
	int WINDOW_TYPE = 1;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW_TYPE__ID = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW_TYPE__NAME = 1;

	/**
	 * The feature id for the '<em><b>UValue</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW_TYPE__UVALUE = 2;

	/**
	 * The feature id for the '<em><b>GValue</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW_TYPE__GVALUE = 3;

	/**
	 * The feature id for the '<em><b>Glazing Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW_TYPE__GLAZING_NUMBER = 4;

	/**
	 * The feature id for the '<em><b>Frame Ratio</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW_TYPE__FRAME_RATIO = 5;

	/**
	 * The number of structural features of the '<em>Window Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW_TYPE_FEATURE_COUNT = 6;

	/**
	 * The number of operations of the '<em>Window Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.buildingphysics.impl.CatalogImpl <em>Catalog</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.buildingphysics.impl.CatalogImpl
	 * @see de.hftstuttgart.buildingphysics.impl.BuildingPhysicsPackageImpl#getCatalog()
	 * @generated
	 */
	int CATALOG = 2;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATALOG__NAME = 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATALOG__DESCRIPTION = 1;

	/**
	 * The feature id for the '<em><b>Source</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATALOG__SOURCE = 2;

	/**
	 * The number of structural features of the '<em>Catalog</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATALOG_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Catalog</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATALOG_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.buildingphysics.impl.WindowCatalogImpl <em>Window Catalog</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.buildingphysics.impl.WindowCatalogImpl
	 * @see de.hftstuttgart.buildingphysics.impl.BuildingPhysicsPackageImpl#getWindowCatalog()
	 * @generated
	 */
	int WINDOW_CATALOG = 3;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW_CATALOG__NAME = CATALOG__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW_CATALOG__DESCRIPTION = CATALOG__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Source</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW_CATALOG__SOURCE = CATALOG__SOURCE;

	/**
	 * The feature id for the '<em><b>Window Types</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW_CATALOG__WINDOW_TYPES = CATALOG_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Window Catalog</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW_CATALOG_FEATURE_COUNT = CATALOG_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Window Catalog</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW_CATALOG_OPERATION_COUNT = CATALOG_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.buildingphysics.impl.MaterialCatalogImpl <em>Material Catalog</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.buildingphysics.impl.MaterialCatalogImpl
	 * @see de.hftstuttgart.buildingphysics.impl.BuildingPhysicsPackageImpl#getMaterialCatalog()
	 * @generated
	 */
	int MATERIAL_CATALOG = 4;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL_CATALOG__NAME = CATALOG__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL_CATALOG__DESCRIPTION = CATALOG__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Source</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL_CATALOG__SOURCE = CATALOG__SOURCE;

	/**
	 * The feature id for the '<em><b>Material Categories</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL_CATALOG__MATERIAL_CATEGORIES = CATALOG_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Material Catalog</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL_CATALOG_FEATURE_COUNT = CATALOG_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Material Catalog</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL_CATALOG_OPERATION_COUNT = CATALOG_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.buildingphysics.impl.MaterialCategoryImpl <em>Material Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.buildingphysics.impl.MaterialCategoryImpl
	 * @see de.hftstuttgart.buildingphysics.impl.BuildingPhysicsPackageImpl#getMaterialCategory()
	 * @generated
	 */
	int MATERIAL_CATEGORY = 5;

	/**
	 * The feature id for the '<em><b>Material</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL_CATEGORY__MATERIAL = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL_CATEGORY__NAME = 1;

	/**
	 * The number of structural features of the '<em>Material Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL_CATEGORY_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Material Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL_CATEGORY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.buildingphysics.impl.MaterialImpl <em>Material</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.buildingphysics.impl.MaterialImpl
	 * @see de.hftstuttgart.buildingphysics.impl.BuildingPhysicsPackageImpl#getMaterial()
	 * @generated
	 */
	int MATERIAL = 6;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL__ID = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL__NAME = 1;

	/**
	 * The feature id for the '<em><b>Density</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL__DENSITY = 2;

	/**
	 * The feature id for the '<em><b>Heat Capacity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL__HEAT_CAPACITY = 3;

	/**
	 * The feature id for the '<em><b>Conductivity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL__CONDUCTIVITY = 4;

	/**
	 * The number of structural features of the '<em>Material</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL_FEATURE_COUNT = 5;

	/**
	 * The number of operations of the '<em>Material</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL_OPERATION_COUNT = 0;

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.buildingphysics.BuildingPhysicsCatalog <em>Catalog</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Catalog</em>'.
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsCatalog
	 * @generated
	 */
	EClass getBuildingPhysicsCatalog();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.buildingphysics.BuildingPhysicsCatalog#getAuthor <em>Author</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Author</em>'.
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsCatalog#getAuthor()
	 * @see #getBuildingPhysicsCatalog()
	 * @generated
	 */
	EAttribute getBuildingPhysicsCatalog_Author();

	/**
	 * Returns the meta object for the containment reference '{@link de.hftstuttgart.buildingphysics.BuildingPhysicsCatalog#getWindowCatalog <em>Window Catalog</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Window Catalog</em>'.
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsCatalog#getWindowCatalog()
	 * @see #getBuildingPhysicsCatalog()
	 * @generated
	 */
	EReference getBuildingPhysicsCatalog_WindowCatalog();

	/**
	 * Returns the meta object for the containment reference '{@link de.hftstuttgart.buildingphysics.BuildingPhysicsCatalog#getMaterialCatalog <em>Material Catalog</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Material Catalog</em>'.
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsCatalog#getMaterialCatalog()
	 * @see #getBuildingPhysicsCatalog()
	 * @generated
	 */
	EReference getBuildingPhysicsCatalog_MaterialCatalog();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.buildingphysics.WindowType <em>Window Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Window Type</em>'.
	 * @see de.hftstuttgart.buildingphysics.WindowType
	 * @generated
	 */
	EClass getWindowType();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.buildingphysics.WindowType#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see de.hftstuttgart.buildingphysics.WindowType#getId()
	 * @see #getWindowType()
	 * @generated
	 */
	EAttribute getWindowType_Id();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.buildingphysics.WindowType#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see de.hftstuttgart.buildingphysics.WindowType#getName()
	 * @see #getWindowType()
	 * @generated
	 */
	EAttribute getWindowType_Name();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.buildingphysics.WindowType#getUValue <em>UValue</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>UValue</em>'.
	 * @see de.hftstuttgart.buildingphysics.WindowType#getUValue()
	 * @see #getWindowType()
	 * @generated
	 */
	EAttribute getWindowType_UValue();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.buildingphysics.WindowType#getGValue <em>GValue</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>GValue</em>'.
	 * @see de.hftstuttgart.buildingphysics.WindowType#getGValue()
	 * @see #getWindowType()
	 * @generated
	 */
	EAttribute getWindowType_GValue();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.buildingphysics.WindowType#getGlazingNumber <em>Glazing Number</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Glazing Number</em>'.
	 * @see de.hftstuttgart.buildingphysics.WindowType#getGlazingNumber()
	 * @see #getWindowType()
	 * @generated
	 */
	EAttribute getWindowType_GlazingNumber();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.buildingphysics.WindowType#getFrameRatio <em>Frame Ratio</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Frame Ratio</em>'.
	 * @see de.hftstuttgart.buildingphysics.WindowType#getFrameRatio()
	 * @see #getWindowType()
	 * @generated
	 */
	EAttribute getWindowType_FrameRatio();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.buildingphysics.Catalog <em>Catalog</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Catalog</em>'.
	 * @see de.hftstuttgart.buildingphysics.Catalog
	 * @generated
	 */
	EClass getCatalog();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.buildingphysics.Catalog#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see de.hftstuttgart.buildingphysics.Catalog#getName()
	 * @see #getCatalog()
	 * @generated
	 */
	EAttribute getCatalog_Name();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.buildingphysics.Catalog#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see de.hftstuttgart.buildingphysics.Catalog#getDescription()
	 * @see #getCatalog()
	 * @generated
	 */
	EAttribute getCatalog_Description();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.buildingphysics.Catalog#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Source</em>'.
	 * @see de.hftstuttgart.buildingphysics.Catalog#getSource()
	 * @see #getCatalog()
	 * @generated
	 */
	EAttribute getCatalog_Source();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.buildingphysics.WindowCatalog <em>Window Catalog</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Window Catalog</em>'.
	 * @see de.hftstuttgart.buildingphysics.WindowCatalog
	 * @generated
	 */
	EClass getWindowCatalog();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.buildingphysics.WindowCatalog#getWindowTypes <em>Window Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Window Types</em>'.
	 * @see de.hftstuttgart.buildingphysics.WindowCatalog#getWindowTypes()
	 * @see #getWindowCatalog()
	 * @generated
	 */
	EReference getWindowCatalog_WindowTypes();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.buildingphysics.MaterialCatalog <em>Material Catalog</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Material Catalog</em>'.
	 * @see de.hftstuttgart.buildingphysics.MaterialCatalog
	 * @generated
	 */
	EClass getMaterialCatalog();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.buildingphysics.MaterialCatalog#getMaterialCategories <em>Material Categories</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Material Categories</em>'.
	 * @see de.hftstuttgart.buildingphysics.MaterialCatalog#getMaterialCategories()
	 * @see #getMaterialCatalog()
	 * @generated
	 */
	EReference getMaterialCatalog_MaterialCategories();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.buildingphysics.MaterialCategory <em>Material Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Material Category</em>'.
	 * @see de.hftstuttgart.buildingphysics.MaterialCategory
	 * @generated
	 */
	EClass getMaterialCategory();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.buildingphysics.MaterialCategory#getMaterial <em>Material</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Material</em>'.
	 * @see de.hftstuttgart.buildingphysics.MaterialCategory#getMaterial()
	 * @see #getMaterialCategory()
	 * @generated
	 */
	EReference getMaterialCategory_Material();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.buildingphysics.MaterialCategory#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see de.hftstuttgart.buildingphysics.MaterialCategory#getName()
	 * @see #getMaterialCategory()
	 * @generated
	 */
	EAttribute getMaterialCategory_Name();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.buildingphysics.Material <em>Material</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Material</em>'.
	 * @see de.hftstuttgart.buildingphysics.Material
	 * @generated
	 */
	EClass getMaterial();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.buildingphysics.Material#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see de.hftstuttgart.buildingphysics.Material#getId()
	 * @see #getMaterial()
	 * @generated
	 */
	EAttribute getMaterial_Id();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.buildingphysics.Material#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see de.hftstuttgart.buildingphysics.Material#getName()
	 * @see #getMaterial()
	 * @generated
	 */
	EAttribute getMaterial_Name();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.buildingphysics.Material#getDensity <em>Density</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Density</em>'.
	 * @see de.hftstuttgart.buildingphysics.Material#getDensity()
	 * @see #getMaterial()
	 * @generated
	 */
	EAttribute getMaterial_Density();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.buildingphysics.Material#getHeatCapacity <em>Heat Capacity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Heat Capacity</em>'.
	 * @see de.hftstuttgart.buildingphysics.Material#getHeatCapacity()
	 * @see #getMaterial()
	 * @generated
	 */
	EAttribute getMaterial_HeatCapacity();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.buildingphysics.Material#getConductivity <em>Conductivity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Conductivity</em>'.
	 * @see de.hftstuttgart.buildingphysics.Material#getConductivity()
	 * @see #getMaterial()
	 * @generated
	 */
	EAttribute getMaterial_Conductivity();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	BuildingPhysicsFactory getBuildingPhysicsFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link de.hftstuttgart.buildingphysics.impl.BuildingPhysicsCatalogImpl <em>Catalog</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.buildingphysics.impl.BuildingPhysicsCatalogImpl
		 * @see de.hftstuttgart.buildingphysics.impl.BuildingPhysicsPackageImpl#getBuildingPhysicsCatalog()
		 * @generated
		 */
		EClass BUILDING_PHYSICS_CATALOG = eINSTANCE.getBuildingPhysicsCatalog();

		/**
		 * The meta object literal for the '<em><b>Author</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BUILDING_PHYSICS_CATALOG__AUTHOR = eINSTANCE.getBuildingPhysicsCatalog_Author();

		/**
		 * The meta object literal for the '<em><b>Window Catalog</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BUILDING_PHYSICS_CATALOG__WINDOW_CATALOG = eINSTANCE.getBuildingPhysicsCatalog_WindowCatalog();

		/**
		 * The meta object literal for the '<em><b>Material Catalog</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BUILDING_PHYSICS_CATALOG__MATERIAL_CATALOG = eINSTANCE.getBuildingPhysicsCatalog_MaterialCatalog();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.buildingphysics.impl.WindowTypeImpl <em>Window Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.buildingphysics.impl.WindowTypeImpl
		 * @see de.hftstuttgart.buildingphysics.impl.BuildingPhysicsPackageImpl#getWindowType()
		 * @generated
		 */
		EClass WINDOW_TYPE = eINSTANCE.getWindowType();

		/**
		 * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute WINDOW_TYPE__ID = eINSTANCE.getWindowType_Id();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute WINDOW_TYPE__NAME = eINSTANCE.getWindowType_Name();

		/**
		 * The meta object literal for the '<em><b>UValue</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute WINDOW_TYPE__UVALUE = eINSTANCE.getWindowType_UValue();

		/**
		 * The meta object literal for the '<em><b>GValue</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute WINDOW_TYPE__GVALUE = eINSTANCE.getWindowType_GValue();

		/**
		 * The meta object literal for the '<em><b>Glazing Number</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute WINDOW_TYPE__GLAZING_NUMBER = eINSTANCE.getWindowType_GlazingNumber();

		/**
		 * The meta object literal for the '<em><b>Frame Ratio</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute WINDOW_TYPE__FRAME_RATIO = eINSTANCE.getWindowType_FrameRatio();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.buildingphysics.impl.CatalogImpl <em>Catalog</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.buildingphysics.impl.CatalogImpl
		 * @see de.hftstuttgart.buildingphysics.impl.BuildingPhysicsPackageImpl#getCatalog()
		 * @generated
		 */
		EClass CATALOG = eINSTANCE.getCatalog();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CATALOG__NAME = eINSTANCE.getCatalog_Name();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CATALOG__DESCRIPTION = eINSTANCE.getCatalog_Description();

		/**
		 * The meta object literal for the '<em><b>Source</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CATALOG__SOURCE = eINSTANCE.getCatalog_Source();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.buildingphysics.impl.WindowCatalogImpl <em>Window Catalog</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.buildingphysics.impl.WindowCatalogImpl
		 * @see de.hftstuttgart.buildingphysics.impl.BuildingPhysicsPackageImpl#getWindowCatalog()
		 * @generated
		 */
		EClass WINDOW_CATALOG = eINSTANCE.getWindowCatalog();

		/**
		 * The meta object literal for the '<em><b>Window Types</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference WINDOW_CATALOG__WINDOW_TYPES = eINSTANCE.getWindowCatalog_WindowTypes();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.buildingphysics.impl.MaterialCatalogImpl <em>Material Catalog</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.buildingphysics.impl.MaterialCatalogImpl
		 * @see de.hftstuttgart.buildingphysics.impl.BuildingPhysicsPackageImpl#getMaterialCatalog()
		 * @generated
		 */
		EClass MATERIAL_CATALOG = eINSTANCE.getMaterialCatalog();

		/**
		 * The meta object literal for the '<em><b>Material Categories</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MATERIAL_CATALOG__MATERIAL_CATEGORIES = eINSTANCE.getMaterialCatalog_MaterialCategories();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.buildingphysics.impl.MaterialCategoryImpl <em>Material Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.buildingphysics.impl.MaterialCategoryImpl
		 * @see de.hftstuttgart.buildingphysics.impl.BuildingPhysicsPackageImpl#getMaterialCategory()
		 * @generated
		 */
		EClass MATERIAL_CATEGORY = eINSTANCE.getMaterialCategory();

		/**
		 * The meta object literal for the '<em><b>Material</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MATERIAL_CATEGORY__MATERIAL = eINSTANCE.getMaterialCategory_Material();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MATERIAL_CATEGORY__NAME = eINSTANCE.getMaterialCategory_Name();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.buildingphysics.impl.MaterialImpl <em>Material</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.buildingphysics.impl.MaterialImpl
		 * @see de.hftstuttgart.buildingphysics.impl.BuildingPhysicsPackageImpl#getMaterial()
		 * @generated
		 */
		EClass MATERIAL = eINSTANCE.getMaterial();

		/**
		 * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MATERIAL__ID = eINSTANCE.getMaterial_Id();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MATERIAL__NAME = eINSTANCE.getMaterial_Name();

		/**
		 * The meta object literal for the '<em><b>Density</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MATERIAL__DENSITY = eINSTANCE.getMaterial_Density();

		/**
		 * The meta object literal for the '<em><b>Heat Capacity</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MATERIAL__HEAT_CAPACITY = eINSTANCE.getMaterial_HeatCapacity();

		/**
		 * The meta object literal for the '<em><b>Conductivity</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MATERIAL__CONDUCTIVITY = eINSTANCE.getMaterial_Conductivity();

	}

} //BuildingPhysicsPackage
